package com.bonus.sgzb.common.core.utils;

import java.util.*;

import com.bonus.sgzb.common.core.constant.Constants;
import com.bonus.sgzb.common.core.text.StrFormatter;
import lombok.extern.slf4j.Slf4j;
import org.springframework.util.AntPathMatcher;

import static com.bonus.sgzb.common.core.constant.Constants.IMAGE_EXTENSIONS;
import static com.bonus.sgzb.common.core.constant.Constants.UPLOAD_FILE_URL_PART;

/**
 * 字符串工具类
 * 
 * @author ruoyi
 */
@Slf4j
public class StringUtils extends org.apache.commons.lang3.StringUtils
{
    /** 空字符串 */
    private static final String NULLSTR = "";

    /** 下划线 */
    private static final char SEPARATOR = '_';

    private static final Map<String, String> CAT_MAP;

    static {
        CAT_MAP = new HashMap<>();
        CAT_MAP.put("线路施工类", "A");
        CAT_MAP.put("变电施工类", "B");
        CAT_MAP.put("特种及其他设备", "C");
        CAT_MAP.put("检修试验", "D");
        CAT_MAP.put("创新装备", "E");
    }

    /**
     1	抱杆	01人字抱杆、02平臂抱杆、03悬浮抱杆、04....
     2	放线及滑车	01牵张设备、02滑车、03....
     3	收紧设备	01电动紧线机、02液压紧线机、03...
     4	线路动力设备	01机动绞磨、02压接机、03飞车及间隔棒运输机、04....
     5	配件及仪器仪表	01锚固、02绳索、03连接器、04全站仪RPK、05附件、06....

     1	一次安装设备	01滤油机、02 SF6回收装置、03排油泵、04真空泵、05....
     2	变电运输设备	01二次屏柜搬运设备、02液压移动小车、03轨道小车、04 GIS运输小坦克、05..

     1	直升机及无人机	01、多旋翼无人机、02固定翼无人机、03巡线直升机、04...
     2	带电清洗设备	01线路水冲洗、02变电水冲洗、03...
     3	起重设备	01汽车起重机、02履带式起重机、03随车起重机、04...
     4	土建设备	01履带式推土机、02液压式挖掘机、03混凝土泵车、05旋挖钻机、06...
     5	运输设备	01厢式货车、02平板货车、03灌式运输车、04履带运输车、05...
     6	高空作业设备	01曲臂升降车、02高处作业平台车、03剪叉式升降平台、04...

     1	一次试验设备	01试验变压器、02高压直流发生器、03绕组直流电阻、04变比测试仪、05...
     2	二次试验设备	01万用表、02电流表、03微安表、04...
     3	油化试验设备	01微水测试仪、02介损测试仪、03...

     1	线路创新装备	01索道自动上下料装置、02遥控索道牵引机、03塔材组片专用装备、04...
     2	变电创新装备	01自动安装机械、02新型模具和加固装置、03 GIS/HGIS设备整体就位装备、04..
     3	其他新装备	01砌筑作业机器人、02高处作业平台车、03电缆敷设智能化控制装备、04...

     map.put("抱杆_人字抱杆","101");
     map.put("抱杆_平臂抱杆","102");
     map.put("抱杆_悬浮抱杆","103");
     map.put("放线及滑车_牵张设备","201");
     map.put("放线及滑车_滑车","202");
     map.put("收紧设备_电动紧线机","301");
     map.put("收紧设备_液压紧线机","302");
     map.put("线路动力设备_机动绞磨","401");
     map.put("线路动力设备_压接机","402");
     map.put("线路动力设备_飞车及间隔棒运输机","403");
     map.put("配件及仪器仪表_锚固","501");
     map.put("配件及仪器仪表_绳索","502");
     map.put("配件及仪器仪表_连接器","503");
     map.put("配件及仪器仪表_全站仪RPK","504");
     map.put("配件及仪器仪表_附件","505");
     */

    /**
     * 获取参数不为空值
     * 
     * @param value defaultValue 要判断的value
     * @return value 返回值
     */
    public static <T> T nvl(T value, T defaultValue)
    {
        return value != null ? value : defaultValue;
    }

    /**
     * * 判断一个Collection是否为空， 包含List，Set，Queue
     * 
     * @param coll 要判断的Collection
     * @return true：为空 false：非空
     */
    public static boolean isEmpty(Collection<?> coll)
    {
        return isNull(coll) || coll.isEmpty();
    }

    /**
     * * 判断一个Collection是否非空，包含List，Set，Queue
     * 
     * @param coll 要判断的Collection
     * @return true：非空 false：空
     */
    public static boolean isNotEmpty(Collection<?> coll)
    {
        return !isEmpty(coll);
    }

    /**
     * * 判断一个对象数组是否为空
     * 
     * @param objects 要判断的对象数组
     ** @return true：为空 false：非空
     */
    public static boolean isEmpty(Object[] objects)
    {
        return isNull(objects) || (objects.length == 0);
    }

    /**
     * * 判断一个对象数组是否非空
     * 
     * @param objects 要判断的对象数组
     * @return true：非空 false：空
     */
    public static boolean isNotEmpty(Object[] objects)
    {
        return !isEmpty(objects);
    }

    /**
     * * 判断一个Map是否为空
     * 
     * @param map 要判断的Map
     * @return true：为空 false：非空
     */
    public static boolean isEmpty(Map<?, ?> map)
    {
        return isNull(map) || map.isEmpty();
    }

    /**
     * * 判断一个Map是否为空
     * 
     * @param map 要判断的Map
     * @return true：非空 false：空
     */
    public static boolean isNotEmpty(Map<?, ?> map)
    {
        return !isEmpty(map);
    }

    /**
     * * 判断一个字符串是否为空串
     * 
     * @param str String
     * @return true：为空 false：非空
     */
    public static boolean isEmpty(String str)
    {
        return isNull(str) || NULLSTR.equals(str.trim());
    }

    /**
     * * 判断一个字符串是否为非空串
     * 
     * @param str String
     * @return true：非空串 false：空串
     */
    public static boolean isNotEmpty(String str)
    {
        return !isEmpty(str);
    }

    /**
     * * 判断一个对象是否为空
     * 
     * @param object Object
     * @return true：为空 false：非空
     */
    public static boolean isNull(Object object)
    {
        return object == null;
    }

    /**
     * * 判断一个对象是否非空
     * 
     * @param object Object
     * @return true：非空 false：空
     */
    public static boolean isNotNull(Object object)
    {
        return !isNull(object);
    }

    /**
     * * 判断一个对象是否是数组类型（Java基本型别的数组）
     * 
     * @param object 对象
     * @return true：是数组 false：不是数组
     */
    public static boolean isArray(Object object)
    {
        return isNotNull(object) && object.getClass().isArray();
    }

    /**
     * 去空格
     */
    public static String trim(String str)
    {
        return (str == null ? "" : str.trim());
    }

    /**
     * 截取字符串
     * 
     * @param str 字符串
     * @param start 开始
     * @return 结果
     */
    public static String substring(final String str, int start)
    {
        if (str == null)
        {
            return NULLSTR;
        }

        if (start < 0)
        {
            start = str.length() + start;
        }

        if (start < 0)
        {
            start = 0;
        }
        if (start > str.length())
        {
            return NULLSTR;
        }

        return str.substring(start);
    }

    /**
     * 截取字符串
     * 
     * @param str 字符串
     * @param start 开始
     * @param end 结束
     * @return 结果
     */
    public static String substring(final String str, int start, int end)
    {
        if (str == null)
        {
            return NULLSTR;
        }

        if (end < 0)
        {
            end = str.length() + end;
        }
        if (start < 0)
        {
            start = str.length() + start;
        }

        if (end > str.length())
        {
            end = str.length();
        }

        if (start > end)
        {
            return NULLSTR;
        }

        if (start < 0)
        {
            start = 0;
        }
        if (end < 0)
        {
            end = 0;
        }

        return str.substring(start, end);
    }

    /**
     * 判断是否为空，并且不是空白字符
     * 
     * @param str 要判断的value
     * @return 结果
     */
    public static boolean hasText(String str)
    {
        return (str != null && !str.isEmpty() && containsText(str));
    }

    private static boolean containsText(CharSequence str)
    {
        int strLen = str.length();
        for (int i = 0; i < strLen; i++)
        {
            if (!Character.isWhitespace(str.charAt(i)))
            {
                return true;
            }
        }
        return false;
    }

    /**
     * 格式化文本, {} 表示占位符<br>
     * 此方法只是简单将占位符 {} 按照顺序替换为参数<br>
     * 如果想输出 {} 使用 \\转义 { 即可，如果想输出 {} 之前的 \ 使用双转义符 \\\\ 即可<br>
     * 例：<br>
     * 通常使用：format("this is {} for {}", "a", "b") -> this is a for b<br>
     * 转义{}： format("this is \\{} for {}", "a", "b") -> this is \{} for a<br>
     * 转义\： format("this is \\\\{} for {}", "a", "b") -> this is \a for b<br>
     * 
     * @param template 文本模板，被替换的部分用 {} 表示
     * @param params 参数值
     * @return 格式化后的文本
     */
    public static String format(String template, Object... params)
    {
        if (isEmpty(params) || isEmpty(template))
        {
            return template;
        }
        return StrFormatter.format(template, params);
    }

    /**
     * 是否为http(s)://开头
     * 
     * @param link 链接
     * @return 结果
     */
    public static boolean ishttp(String link)
    {
        return StringUtils.startsWithAny(link, Constants.HTTP, Constants.HTTPS);
    }

    /**
     * 判断给定的collection列表中是否包含数组array 判断给定的数组array中是否包含给定的元素value
     *
     * @param collection 给定的集合
     * @param array 给定的数组
     * @return boolean 结果
     */
    public static boolean containsAny(Collection<String> collection, String... array)
    {
        if (isEmpty(collection) || isEmpty(array))
        {
            return false;
        }
        else
        {
            for (String str : array)
            {
                if (collection.contains(str))
                {
                    return true;
                }
            }
            return false;
        }
    }

    /**
     * 驼峰转下划线命名
     */
    public static String toUnderScoreCase(String str) {
        if (str == null) {
            return null;
        }
        StringBuilder sb = new StringBuilder();
        // 前置字符是否大写
        boolean preCharIsUpperCase = true;
        // 当前字符是否大写
        boolean curreCharIsUpperCase = true;
        // 下一字符是否大写
        boolean nexteCharIsUpperCase = true;
        for (int i = 0; i < str.length(); i++) {
            char c = str.charAt(i);
            if (i > 0) {
                preCharIsUpperCase = Character.isUpperCase(str.charAt(i - 1));
            } else {
                preCharIsUpperCase = false;
            }

            curreCharIsUpperCase = Character.isUpperCase(c);

            if (i < (str.length() - 1)) {
                nexteCharIsUpperCase = Character.isUpperCase(str.charAt(i + 1));
            }

            if (preCharIsUpperCase && curreCharIsUpperCase && !nexteCharIsUpperCase) {
                sb.append(SEPARATOR);
            } else if ((i != 0 && !preCharIsUpperCase)) {
                if (curreCharIsUpperCase){
                    sb.append(SEPARATOR);
                }
            }
            sb.append(Character.toLowerCase(c));
        }

        return sb.toString();
    }

    /**
     * 是否包含字符串
     * 
     * @param str 验证字符串
     * @param strs 字符串组
     * @return 包含返回true
     */
    public static boolean inStringIgnoreCase(String str, String... strs)
    {
        if (str != null && strs != null)
        {
            for (String s : strs)
            {
                if (str.equalsIgnoreCase(trim(s)))
                {
                    return true;
                }
            }
        }
        return false;
    }

    /**
     * 将下划线大写方式命名的字符串转换为驼峰式。如果转换前的下划线大写方式命名的字符串为空，则返回空字符串。 例如：HELLO_WORLD->HelloWorld
     * 
     * @param name 转换前的下划线大写方式命名的字符串
     * @return 转换后的驼峰式命名的字符串
     */
    public static String convertToCamelCase(String name)
    {
        StringBuilder result = new StringBuilder();
        // 快速检查
        if (name == null || name.isEmpty())
        {
            // 没必要转换
            return "";
        }
        else if (!name.contains(GlobalConstants.STRING_UNDERLINE))
        {
            // 不含下划线，仅将首字母大写
            return name.substring(0, 1).toUpperCase() + name.substring(1);
        }
        // 用下划线将原始字符串分割
        String[] camels = name.split("_");
        for (String camel : camels)
        {
            // 跳过原始字符串中开头、结尾的下换线或双重下划线
            if (camel.isEmpty())
            {
                continue;
            }
            // 首字母大写
            result.append(camel.substring(0, 1).toUpperCase());
            result.append(camel.substring(1).toLowerCase());
        }
        return result.toString();
    }

    /**
     * 驼峰式命名法
     * 例如：user_name->userName
     */
    public static String toCamelCase(String s)
    {
        if (s == null)
        {
            return null;
        }
        if (s.indexOf(SEPARATOR) == -1)
        {
            return s;
        }
        s = s.toLowerCase();
        StringBuilder sb = new StringBuilder(s.length());
        boolean upperCase = false;
        for (int i = 0; i < s.length(); i++)
        {
            char c = s.charAt(i);

            if (c == SEPARATOR)
            {
                upperCase = true;
            }
            else if (upperCase)
            {
                sb.append(Character.toUpperCase(c));
                upperCase = false;
            }
            else
            {
                sb.append(c);
            }
        }
        return sb.toString();
    }

    /**
     * 查找指定字符串是否匹配指定字符串列表中的任意一个字符串
     * 
     * @param str 指定字符串
     * @param strs 需要检查的字符串数组
     * @return 是否匹配
     */
    public static boolean matches(String str, List<String> strs)
    {
        if (isEmpty(str) || isEmpty(strs))
        {
            return false;
        }
        for (String pattern : strs)
        {
            if (isMatch(pattern, str))
            {
                return true;
            }
        }
        return false;
    }

    /**
     * 判断url是否与规则配置: 
     * ? 表示单个字符; 
     * * 表示一层路径内的任意字符串，不可跨层级; 
     * ** 表示任意层路径;
     * 
     * @param pattern 匹配规则
     * @param url 需要匹配的url
     * @return
     */
    public static boolean isMatch(String pattern, String url)
    {
        AntPathMatcher matcher = new AntPathMatcher();
        return matcher.match(pattern, url);
    }

    @SuppressWarnings("unchecked")
    public static <T> T cast(Object obj)
    {
        return (T) obj;
    }

    /**
     * 数字左边补齐0，使之达到指定长度。注意，如果数字转换为字符串后，长度大于size，则只保留 最后size个字符。
     * 
     * @param num 数字对象
     * @param size 字符串指定长度
     * @return 返回数字的字符串格式，该字符串为指定长度。
     */
    public static final String padl(final Number num, final int size)
    {
        return padl(num.toString(), size, '0');
    }

    /**
     * 字符串左补齐。如果原始字符串s长度大于size，则只保留最后size个字符。
     * 
     * @param s 原始字符串
     * @param size 字符串指定长度
     * @param c 用于补齐的字符
     * @return 返回指定长度的字符串，由原字符串左补齐或截取得到。
     */
    public static final String padl(final String s, final int size, final char c)
    {
        final StringBuilder sb = new StringBuilder(size);
        if (s != null)
        {
            final int len = s.length();
            if (s.length() <= size)
            {
                for (int i = size - len; i > 0; i--)
                {
                    sb.append(c);
                }
                sb.append(s);
            }
            else
            {
                return s.substring(len - size, len);
            }
        }
        else
        {
            for (int i = size; i > 0; i--)
            {
                sb.append(c);
            }
        }
        return sb.toString();
    }

    /** 生成工器具编码：  类似CSG-A101-2024061900001 */
    public static String getDeviceCode(String ownerCode, String intelligentCode, Date date, String maId) {
        int number = Integer.parseInt(maId);
        if (number > 30000) {
            number = number % 30000;
        }
        String numberStr =  String.format("%05d", number);
        String deviceCode = ownerCode + "-" + intelligentCode + "-" + DateUtils.getDateTimeString(date) + numberStr;
        return deviceCode;
    }

//    public static void main(String[] args) {
//        System.out.println(getDeviceCode("CSG", "线路施工类", "102", new Date(), "500322"));
//    }

    public static boolean checkIfFileUrlsValid(String fileUrls) {
        boolean url_valid = true;
        if (StringUtils.isEmpty(fileUrls)) {
            return true;
        } else {
            String[] fileUrlArray = fileUrls.split(",");
            for (String fileUrl : fileUrlArray) {
                if (!fileUrl.toLowerCase().contains(UPLOAD_FILE_URL_PART)) {
                    url_valid = false;
                }
            }
            return url_valid;
        }
    }

    public static boolean checkFileUrlsEndWithExtensions(String fileUrls) {
        if (StringUtils.isEmpty(fileUrls)) {
            return true;
        } else {
            String[] fileUrlArray = fileUrls.split(",");
            List<String> fileUrlList = Arrays.asList(fileUrlArray);
            for (String fileUrl : fileUrlList) {
                boolean endsWithExtension = false;
                for (String extension : IMAGE_EXTENSIONS) {
                    if (fileUrl.toLowerCase().endsWith(extension)) {
                        endsWithExtension = true;
                        break;
                    }
                }
                if (!endsWithExtension) {
                    return false;
                }
            }
            return true;
        }
    }

    public static void main(String[] args) {
        String fileUrls = "https://example.com/file1.png,https://example.com/file2.gif";
        boolean allEndWithExtensions = checkFileUrlsEndWithExtensions(fileUrls);
        System.out.println("所有文件URL都以给定的扩展名结尾： " + allEndWithExtensions);
    }
}
